import type {Complex} from '@/Complex/type'
import {implementations} from '@/core/Dispatcher'
import {$reflect} from '@/interfaces/type'
import type {CommonSignature} from '@/interfaces/type'

export const number_type = {
   name: 'number',
   before: ['Complex'],
   test: (n: unknown): n is number => typeof n === 'number',
   from: {string: (s: string) => +s }
}

declare module "@/interfaces/type" {
   interface AssociatedTypes<T> {
      number: {
         type: number
         zero: 0
         one: 1
         nan: typeof NaN
         real: number
         closure: Complex<number>
      }
   }
}

export const common = implementations<CommonSignature<number>>()
   .independent({
      zero: a => 0,
      one: a => 1,
      nan: a => NaN,
      re: a => a
   }).ship()

$reflect!([common])
